var template = ''
$.ajax('../../../component/statistics/PersonInfo/index.html', {
  data: {},
  dataType: 'html',
  cache: false,
  timeout: 60000,
  async: false,
  error: function (res) {},
  success: function (res) {
    template = res
  }
})

Vue.component('person-info', {
  template: template,
  props: [],
  data: function () {
    return {
      visible: false,
      type: '1',
      assessment: [
        {
          year: '2024',
          children: [
            {
              date: '12-17',
              time: '16:09:18',
              risk: '高危',
              doctor: '黄琴',
              status: '住院补筛'
            },
            {
              date: '11-17',
              time: '16:09:18',
              risk: '高危',
              doctor: '黄琴',
              status: '已提醒'
            },
            {
              date: '10-17',
              time: '16:09:18',
              risk: '中危',
              doctor: '黄琴',
              status: '已管理'
            }
          ]
        }
      ],
      turnup: [
        {
          year: '2024',
          children: [
            {
              date: '12-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              dept: '心血管医院',
              doctor: '陈晓卿'
            },
            {
              date: '11-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              dept: '心血管医院',
              doctor: '陈晓卿'
            },
            {
              date: '10-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              dept: '心血管医院',
              doctor: '陈晓卿'
            }
          ]
        }
      ],
      jzList: [
        {
          year: '2024',
          children: [
            {
              date: '12-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              dept: '心内科门诊',
              diagnostic: '胸闷',
              type: '门诊'
            },
            {
              date: '11-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              dept: '心内科门诊',
              diagnostic: '冠状动脉粥样硬化性心脏病',
              type: '住院'
            },
            {
              date: '10-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              dept: '心内科门诊',
              diagnostic: '胸闷',
              type: '门诊'
            }
          ]
        }
      ],
      turnDown: [
        {
          year: '2024',
          children: [
            {
              date: '12-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              doctor: '黄琴',
              community: '思明区中华街道社区卫生服务中心',
              receiveDoc: '陈晓卿',
              type: '住院'
            },
            {
              date: '11-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              doctor: '黄琴',
              community: '思明区中华街道社区卫生服务中心',
              receiveDoc: '陈晓卿',
              type: '门诊'
            },
            {
              date: '10-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              doctor: '黄琴',
              community: '思明区中华街道社区卫生服务中心',
              receiveDoc: '陈晓卿',
              type: '门诊'
            }
          ]
        }
      ],
      rehabilitation: [
        {
          year: '2024',
          children: [
            {
              date: '12-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              community: '思明区中华街道社区卫生服务中心',
              receiveDoc: '陈晓卿',
              type: '门诊'
            },
            {
              date: '11-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              community: '思明区中华街道社区卫生服务中心',
              receiveDoc: '陈晓卿',
              type: '门诊'
            },
            {
              date: '10-17',
              time: '16:09:18',
              hospital: '厦门大学附属心血管医院',
              community: '思明区中华街道社区卫生服务中心',
              receiveDoc: '陈晓卿',
              type: '门诊'
            }
          ]
        }
      ],
      rehabilitationDetailVisible: false,
      sfList: [
        { doctor: '黄琴', date: '2024-12-19', time: '14:12:16', hospital: '思明区中华街道社区卫生服务中心', status: '0' },
        { doctor: '黄琴', date: '2024-12-19', time: '14:12:16', hospital: '思明区中华街道社区卫生服务中心', status: '0' },
        { doctor: '黄琴', date: '2024-12-19', time: '14:12:16', hospital: '思明区中华街道社区卫生服务中心', status: '1' },
        { doctor: '黄琴', date: '2024-12-19', time: '14:12:16', hospital: '思明区中华街道社区卫生服务中心', status: '1' }
      ]
    }
  },
  methods: {
    openDialog(type) {
      this.visible = true
      this.type = type
    },
    closeDialog() {
      this.visible = false
    },
    copyToClipboard(text) {
      var textarea = document.createElement('textarea')
      textarea.style.position = 'fixed'
      textarea.style.opacity = 0
      textarea.value = text
      document.body.appendChild(textarea)
      textarea.select()
      document.execCommand('copy')
      document.body.removeChild(textarea)
      this.$message.success('复制成功')
    },
    toDetail(){

    },
    toRehabilitationDetail(){
      this.rehabilitationDetailVisible = true
    },
    back(){
      this.rehabilitationDetailVisible = false
    }
  },
  mounted() {}
})
